#include "Bomber.h"
#include "Bomb.h"
#include "InputHandler.h"
#include "BombHandler.h"
#include "TextureManager.h"

#include <vector>

Bomber::Bomber() :
		m_direction(1),has_bomb(false) {
	//m_direction = 1;
	cout << "Bomber Constructor " << endl;

}

Bomber::~Bomber() {

	cout << "Bomber Destructor " << endl;

}

void Bomber::update() {
	//m_y += 1;
	m_x += 2 * m_direction;
	if (m_x > 588 || m_x < 30)
		m_direction *= -1;
	m_currentFrame = 0;
	if (TheInputHandler::Instance()->isKeyDown(SDL_SCANCODE_SPACE)   ) {
		 if(m_bombCounter == m_bombDropSpeed) {
			 if (has_bomb == false) {
					m_bomb= new Bomb();
					has_bomb = true;
					m_bomb->load(m_x,m_y + 40,32,32, "bomb");
			 } else {

				 //delete m_bomb;
				 TheBombHandler::Instance()->addBomb(m_bomb);
				 has_bomb = false;
			 }
		}
		m_bombCounter++;

	} else {
		m_bombCounter = m_bombDropSpeed;
	}

	if (has_bomb == true) {
		m_bomb->setX(m_x);
		m_bomb->update();
	}
	BombHandler::Instance()->updateBombs();
}

void Bomber::load(int x, int y, int width, int height, std::string textureID) {
	GameObject::load(x, y, width, height, textureID);
	//load(x, y, width, height, textureID);
}

void Bomber::draw(SDL_Renderer* pRenderer) {
	//TextureManager::Instance()->scaleFrame(m_textureID, m_x, m_y, m_width, m_height, m_destWidth, m_destHeight, m_currentRow, m_currentFrame, pRenderer);
	 //TextureManager::Instance()->drawFrame(m_textureID, m_x, m_y, m_width, m_height, m_currentRow, m_currentFrame, pRenderer);
	GameObject::draw(pRenderer);
	if (has_bomb == true)
		m_bomb->draw(pRenderer);
	BombHandler::Instance()->drawBombs(pRenderer);
}

void Bomber::clean() {
}

