#include "Game.h"

// our Game object
Game* g_game = 0;

const int FPS = 60;
const int DELAY_TIME = 1000.0f / FPS;

int main(int argc, char* argv[]) {
	Uint32 frameStart, frameTime;
	//g_game = new Game();

	if (TheGame::Instance()->init("Mad Bomber", 100, 100, 640, 480, true) ) {

		std::cout << "game init success!\n";

		while (TheGame::Instance()->running()) {
			frameStart = SDL_GetTicks();

			TheGame::Instance()->handleEvents();
			TheGame::Instance()->update();
			TheGame::Instance()->render();

			frameTime = SDL_GetTicks() - frameStart;

			if (frameTime < DELAY_TIME) {
				SDL_Delay((int) (DELAY_TIME - frameTime));
			}
		}

	}
    std::cout << "game closing...\n";
    TheGame::Instance()->clean();

	//cin.get();

	return 0;
}
